/*
 * Copyright (c) 2018-2999 广州亚米信息科技有限公司 All rights reserved.
 *
 * https://www.gz-yami.com/
 *
 */

package com.yami.shop.groupbuy.comment.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.yami.shop.groupbuy.comment.api.dto.ApiGroupActivityDto;
import com.yami.shop.groupbuy.comment.api.dto.ApiGroupUserDto;
import com.yami.shop.groupbuy.comment.api.dto.ApiGroupUserOrderDto;
import com.yami.shop.groupbuy.comment.model.GroupOrder;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;

import java.util.List;

/**
 * @author LGH
 * @date 2019-08-27 17:55:57
 */
public interface GroupOrderService extends IService<GroupOrder> {

    /**
     * 获取参团的用户列表
     *
     * @param groupTeamId 拼团单ID
     * @return ApiGroupUserDto列表
     */
    List<ApiGroupUserDto> listApiGroupUserDto(Long groupTeamId);


    /**
     * 将确认订单的信息放入缓存
     */
    ApiGroupUserOrderDto putConfirmOrderCache(String userId, ApiGroupUserOrderDto apiGroupUserOrderDto);

    /**
     * 获取缓存中确认订单的信息
     */
    ApiGroupUserOrderDto getConfirmOrderCache(String userId);

    /**
     * 移除缓存中确认订单的信息
     */
    void removeConfirmOrderCache(String userId);

    /**
     * 提交订单
     */
    String submit(String userId, ApiGroupUserOrderDto hadConfirmOrder, String remark);

    /**
     * 通过活动商品id获取拼团订单列表
     */
    List<GroupOrder> listByGroupProdId(Long groupActivityId, String userId);

    /**
     * 通过活动商品id获取用户已下单的商品数量
     */
    Integer getUserHadOrderCountByGroupProdId(String userId, Long groupProdId);

    /**
     * 获取用户未成团的订单数量
     */
    int getUserUnGroupOrderCount(String userId, Long groupProdId);

    /**
     * 取消团购订单
     * @return
     */
    int cancelGroupOrder(String orderNumber, int status);
}
